#
# Copyright (C) 2013 - present Instructure, Inc.
#
# This file is part of Canvas.
#
# Canvas is free software: you can redistribute it and/or modify it under
# the terms of the GNU Affero General Public License as published by the Free
# Software Foundation, version 3 of the License.
#
# Canvas is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
# A PARTICULAR PURPOSE. See the GNU Affero General Public License for more
# details.
#
# You should have received a copy of the GNU Affero General Public License along
# with this program. If not, see <http://www.gnu.org/licenses/>.

class DropBodyAndSmsBodyColumns < ActiveRecord::Migration[4.2]
  tag :postdeploy

  def self.up
    remove_column :notifications, :body
    remove_column :notifications, :sms_body
    ::ActiveRecord::Base.connection.schema_cache.clear!
    Notification.reset_column_information
  end

  def self.down
    create_column :notifications, :body, :text
    create_column :notifications, :sms_body, :text
  end
end
