#
# Copyright (C) 2016 - present Instructure, Inc.
#
# This file is part of Canvas.
#
# Canvas is free software: you can redistribute it and/or modify it under
# the terms of the GNU Affero General Public License as published by the Free
# Software Foundation, version 3 of the License.
#
# Canvas is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
# A PARTICULAR PURPOSE. See the GNU Affero General Public License for more
# details.
#
# You should have received a copy of the GNU Affero General Public License along
# with this program. If not, see <http://www.gnu.org/licenses/>.

module GradingPeriodHelper
  def self.date_in_closed_grading_period?(date, periods)
    return false if periods.empty?

    if date.nil?
      periods.sort_by(&:end_date).last.closed?
    else
      periods.any? do |period|
        period.in_date_range?(date) && period.closed?
      end
    end
  end
end
