#
# Copyright (C) 2015 - present Instructure, Inc.
#
# This file is part of Canvas.
#
# Canvas is free software: you can redistribute it and/or modify it under
# the terms of the GNU Affero General Public License as published by the Free
# Software Foundation, version 3 of the License.
#
# Canvas is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
# A PARTICULAR PURPOSE. See the GNU Affero General Public License for more
# details.
#
# You should have received a copy of the GNU Affero General Public License along
# with this program. If not, see <http://www.gnu.org/licenses/>.

# should be run before login/registration
class LoginHooks
  def self.on_login(&block)
    raise ArgumentError unless block.arity == 1
    @hooks ||= []
    @hooks << block
  end

  def self.run_hooks(request)
    (@hooks || []).each do |hook|
      hook.call(request)
    end
  end
end